"""Simulates timed snapshots for tests"""
import posix
import time
import random

from utils.logger import log

class Repository:
    def __init__(self, path):
        self.path = path
        self.version_stamps = {
        }
        self._aliases = { }
        self.now = time.time()
        self.current_version = 0

    def create(self):
        pass

    def has(self, x):
        return True

    def snapshot(self):
        self.current_version += 1
        self.now += 3600 + random.randint(0, 45)
        self.version_stamps[self.current_version] = self.now

    def versions(self):
        return self.version_stamps.keys()

    def stat(self, r, v=None):
        if not v:
            v = self.current_version
        t = self.version_stamps[v]
        return posix.stat_result(
            (0755, 1, 1, 1, 0, 0, 1024, t, t, t)
        )

    def aliases(self):
        return self._aliases

    def version_alias(self, alias, v):
        self._aliases[alias] = v

    def remove_version(self, v):
        del self.version_stamps[v]
        for k, ver in self._aliases.iteritems():
            if v == ver:
                self.aliases[k] = 'broken'

    def update_metas(self, path, metas):
        pass
