#!/usr/bin/python
# vim: ts=4:sw=4:et
import os
import sys
import getopt
import signal

# File mode creation mask of the daemon.
UMASK = 022
PIDFILE = '/var/run/gsync.pid'

class Daemon:
    def daemonize(self):
        try:         
            pid = int(file(PIDFILE).read())
            os.kill(pid, 0)
            return False
        except IOError, e:
            pass
        except OSError, e:
            pass

        try:
            pid = os.fork()
            if pid > 0:
                # exit first parent
                return True
        except OSError, e:
            print "fork #1 failed: %d (%s)" % (e.errno, e.strerror)
            sys.exit(1)

        # decouple from parent environment
        os.setsid()
        os.chdir('/') #don't prevent unmounting
        os.umask(UMASK)

        # do second fork
        try:
            pid = os.fork()
            if pid > 0:
                os._exit(0)
            else:
                open(PIDFILE,'w').write("%d" % os.getpid())
                try:
                    null = file('/dev/null', 'rw')
                    os.dup2(null.fileno(), sys.stdin.fileno())
                    os.dup2(null.fileno(), sys.stdout.fileno())
                    os.dup2(null.fileno(), sys.stderr.fileno())
                    self.main()
                finally:
                    os.unlink(PIDFILE)
        except OSError, e:
            print "fork #2 failed: %d (%s)" % (e.errno, e.strerror)
            sys.exit(1)

        sys.exit(0)

if __name__ == '__main__':
    class testCls(Daemon):
        def main(self):
            import time
            print 'sleeping'
            time.sleep(10)
            print 'exiting'

    x = testCls()
    print x.daemonize()
